---
title: LocalFileSystemSync
slug: Web/API/LocalFileSystemSync
tags:
  - API
  - File API
  - File System API
  - Offline
  - Reference
  - Référence(2)
  - filesystem
---
<div>{{APIRef("File System API")}}{{non-standard_header()}}</div>

<p>The <code>LocalFileSystemSync</code> interface of the <a href="/en/DOM/File_API/File_System_API" title="en/DOM/File_API/File_System_APIB">File System API</a> gives you access to a sandboxed file system. It is intended to be used with <a href="/en/DOM/Worker" title="en/DOM/Worker"> WebWorkers</a>. The methods are implemented by <a href="/en/DOM/Worker" title="En/DOM/Worker">worker</a> objects.</p>

<h2 id="About_this_document">About this document</h2>

<p>This document was last updated on March 2, 2012 and follows the <a class="external" href="http://www.w3.org/TR/file-system-api/">W3C Specifications (Working Draft)</a> drafted on April 19, 2011.</p>

<p>This specification is more or less abandonned, failing to get significant traction.</p>

<h2 id="Basic_concepts">Basic concepts</h2>

<p>You can request access to a sandboxed file system by requesting <code>LocalFileSystemSync</code> object from within a web worker. The global methods in the <code>window</code> object <code>requestFileSystemSync()</code> and <code>resolveLocalFileSystemSyncURL()</code> methods are exposed to the Worker's global scope. Calling <code>window.requestFileSystemSync()</code> for creates new storage for your web app.</p>

<p>For more concepts, see the counterpart <a href="/en/DOM/File_API/File_System_API/LocalFileSystem#Basic_concepts">article for the asynchronous API</a>.</p>

<h3 id="Example">Example</h3>

<pre class="brush: js">//Taking care of the browser-specific prefix
window.requestFileSystemSync  = window.requestFileSystemSync || window.webkitRequestFileSystemSync;

// The first parameter defines the type of storage: persistent or temporary
// Next, set the size of space needed (in bytes)
// initFs is the success callback
// And the last one is the error callback
// for denial of access and other errors.

var fs = requestFileSystemSync(TEMPORARY, 1024*1024 /*1MB*/);</pre>

<p>Because you are using a synchronous API, you don't need success and error callbacks.</p>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code>FileSystemSync <a href="#requestFileSystemSync">requestFileSystemSync</a> (in unsigned short <em>type</em>, in long long <em>size</em>) raises <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>; </code></td>
  </tr>
  <tr>
   <td><code>EntrySync <a href="#resolveLocalFileSystemSyncURL" title="resolveLocalFileSystemSyncURL">resolveLocalFileSystemSyncURL</a> (in DOMString <em>url</em>) raises <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>;</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Constants">Constants</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a name="const_temporary"><code>TEMPORARY</code></a></td>
   <td><code>0</code></td>
   <td>
    <p>Transient storage that can be removed by the browser at its discretion.</p>
   </td>
  </tr>
  <tr>
   <td><a name="const_persistent"><code>PERSISTENT</code></a></td>
   <td><code>1</code></td>
   <td>Storage that stays in the browser unless the user or the app expunges it.</td>
  </tr>
 </tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="requestFileSystem">requestFileSystemSync()</h3>

<p>Requests a file system where data should be stored. You access a sandboxed file system by requesting a <code>LocalFileSystemSync</code> object from within a web worker using this global method, <code>window.requestFileSystemSync()</code>. [ RESEARCH ]</p>

<pre><code>FileSystemSync</code> requestFileSystemSync(
  in unsigned short type,
  in unsigned long long size
);</pre>

<h5 id="Parameters">Parameters</h5>

<dl>
 <dt>type</dt>
 <dd>The storage type of the file system. The values can be either <code><a href="#const_temporary">TEMPORARY</a></code> or <code><a href="#const_persistent">PERSISTENT</a></code>.</dd>
 <dt>size</dt>
 <dd>The storage space—in bytes—that you need for your app.</dd>
</dl>

<h5 id="Returns">Returns</h5>

<dl>
 <dt><code><a href="/en/DOM/File_API/File_System_API/FileSystemSync" title="en/DOM/File_API/File_System_API/FileSystemSync">FileSystemSync</a></code></dt>
 <dd>An object that represents the file system.</dd>
</dl>

<h5 id="Exceptions">Exceptions</h5>

<p>This method can raise an <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following code:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td><code>SECURITY_ERROR</code></td>
   <td>The application does not have permission to access the file system interface. For example, you cannot run from <code>file://</code>. For more details, see the <a href="/en/DOM/File_APIs/Filesystem/Basic_Concepts_About_the_Filesystem_API#You_cannot_run_your_app_from_file:.2F.2F">article on basic concepts</a>.</td>
  </tr>
 </thead>
</table>

<h3 id="resolveLocalFileSystemSyncURL()">resolveLocalFileSystemSyncURL()</h3>

<p>Allows the user to look up the <code>Entry</code> for a file or directory referred to by a local URL.</p>

<pre>void resolveLocalFileSystemURL(
  in DOMString url
);</pre>

<h5 id="Parameter">Parameter</h5>

<dl>
 <dt>url</dt>
 <dd>The URL of a local file in the file system.</dd>
</dl>

<h5 id="Returns_2">Returns</h5>

<dl>
 <dt><code><a href="/en/DOM/File_API/File_System_API/EntrySync" title="en/DOM/File_API/File_System_API/EntrySync">EntrySync</a></code></dt>
 <dd>An object that represents entries in the file system.</dd>
</dl>

<h5 id="Exceptions_2">Exceptions</h5>

<p>This method can raise a <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following codes:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td><code>ENCODING_ERR</code></td>
   <td>The syntax of the URL was invalid.</td>
  </tr>
  <tr>
   <td><code>NOT_FOUND_ERR</code></td>
   <td>The URL was structurally correct, but refers to a resource that does not exist.</td>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>SECURITY_ERR</code></td>
   <td>The application does not have permission to access the file system interface.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("api.LocalFileSystemSync")}}</p>

<h2 id="See_also">See also</h2>

<p>Specification:{{ spec("http://dev.w3.org/2009/dap/file-system/pub/FileSystem/", "File API: Directories and System Specification", "WD") }}</p>

<p>Reference: <a href="/en/DOM/File_API/File_System_API" title="en/DOM/File_API/File_System_API">File System API</a></p>

<p>Introduction: <a href="/en/DOM/File_APIs/Filesystem/Basic_Concepts_About_the_Filesystem_API" title="en/DOM/File_APIs/Filesystem/Basic_Concepts_About_the_Filesystem_API">Basic Concepts About the File System API</a></p>
